"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function composePromise(f1, f2) {
    return function comp(x) {
        var p = f2(x);
        if (p != null && typeof p.then === 'function')
            return p.then(f1);
        return f1(p);
    };
}
exports.composePromise = composePromise;
function waitAll(promises) {
    var n = promises.length;
    if (n === 0)
        return Promise.resolve();
    return new Promise(function (resolve, reject) {
        var count = function () { if (--n === 0)
            resolve(void 0); };
        for (var k = 0; k < n; ++k)
            Promise.resolve(promises[k]).then(count, reject);
    });
}
exports.waitAll = waitAll;
//# sourceMappingURL=helpers.js.map